.TH PLIP.DEVICE 1 "Release 4" "Version 38.11"
.SH NAME
PLIP - A Parallel Line IP SANA2 Device Driver
.SH OVERVIEW
PLIP is a network device driver conforming to the SANA2 standard.  It
allows linking of two Amigas using their parallel ports.  Transfer speed
is around 40 kbyte/sec.  The complete low level transfer protocol is
integrated in the device driver, including port arbitration handshaking and
interrupt driven reads.  Although the transfer process itself is cpu
intensive, the device needs no cpu resources when no transfer is in
progress.
.LP
PLIP is intended as a low-cost networking solution, since the capabilities
of the parallel hardware are somewhat limited.  However, it gives much
better results than SLIP and leaves the serial port free.
.SH REQUIREMENTS
You will need  at  least kickstart and workbench V2.04 (37.175)  to use
PLIP. Also some SANA2 compliant networking protocol (like Envoy, AS225R2 or
AmiTCP) will come in handy :-).
.SH INSTALLATION
Just copy plip.device to devs:networks.  See the documentation of your
networking package for further installation steps.  If you are going to use
both Envoy and AS225 over PLIP at the same time, be sure to first start
Envoy, then AS225.  If you've got problems with multiple protocol stacks
you might try making the packet and host IDs for each protocol unique.
.LP
Since PLIP only allows two hosts to be linked together, addressing is
limited to 1 Bit.  One host uses plip.device, Unit 0, the other one
plip.device, Unit 1.  The device will not work if both machines use the
same unit number.
.LP
PLIP looks for an environment variable called ENV:SANA2/PLIP.config. This
should contain one line terminated with a newline, which will be parsed by
ReadArgs according to the template
.TP 8
.B TIMEOUT/K/N,PRIORITY=PRI/K/N,MTU/K/N,BPS/K/N,RETRIES/K/N where
.TP 8
.B TIMEOUT=num
Packet receive timeout, default is 330000.
Set to a higher value if you have problems
with slow machines.
.TP 8
.B PRIORITY=num
PLIP task priority, default is 15. Do not
change this.
.TP 8
.B MTU=num
Maximum packet data size, default and maximum
is 8192. If you change this, be sure to change
it on both machines to the same value!
.TP 8
.B BPS=num
The nominal bits per second rate returned
from a device query. Default is 25000 which
is much too low but works with beta Envoy.
.TP 8
.B RETRIES=num
The maximum number of times, the driver tries
to resend a packet on error. Default is 63 which
means a total of 64 tries.
.LP
An example PLIP.config is included. All recognized parameters will be
printed into the startup window of PLIP. If PLIP does not run or shows
problems transmitting data first try deleting the PLIP.config file on all
connected machines, so PLIP uses the internal default values. If that
doesn't help, please contact us (see end of documentation).
.SH CABLE
You will need male (A1000: female) DB25 connectors and some (up to 4 meters) parallel
cable. Connect:
.LP
.nf
	D0-D7/BUSY/POUT   to   D0-D7/BUSY/POUT
	ACK               to   STROBE
	STROBE            to   ACK
	GND               to   GND
.fi
.LP
You can look up the pin assignment in your Amiga User Manual, appendix A.
Please note that this cable differs from ParNet! Double check before using!
.LP
There is a potential problem with the RI (ring indicator) line on the
serial port. If you have problems running PLIP, first try to remove any
device connected to the serial port. If that helps, you might try cutting
the RI line in the serial connector.
.SH COPYRIGHT
Under no circumstances may PLIP be used on any machine which is used for
the research, development, construction, testing or production of weapons
or other military applications.  This also includes any machine which is
used for training persons for any of the above mentioned purposes.
.LP
This is the only restriction, in all other respects you may do
with PLIP what you want. Please keep us informed about any
enhancements you make.
.LP
Use PLIP at your own risk.  Please send bug reports to:
.nf
	o.wagner@aworld-2.aworld.de
.fi
or
.nf
	m.balzer@aworld.aworld.de
.fi
.LP
Please exactly state the machine configuration which causes PLIP to fail.
.SH HISTORY
.B V37.11
.nf
 - small speedups in transmission handshaking
 - now uses utility library for parsing the buffer
   management taglist
.fi
.LP
.B V37.14
.nf
 - optimized BPS and MTU
 - cleaned up the code
.fi
.LP
.B V38.5
.nf
 - fixed CRC check
 - added information window
 - some protocol fixes
.fi
.LP
.B V38.7
.nf
 - changed hardware type to 13 (official PLIP ID)
 - added configuration mechanism
.fi
.LP
.B V38.9
.nf
 - some race conditions eliminated
 - packet sequencing corrected
 - added write retry mechanism (configurable)
 - fixed possible AbortIO bug
 - seems to work with Envoy 37.131, at least using
   the default config...
.fi
.LP
.B V38.10
.nf
 - fixed bug with configuration during startup
 - default MTU reduced to 1024 bytes
.fi
.LP
.B V38.11
.nf
 - added tracktype support (beta) in order to make
   PLIP work in conjunction with AmiTCP
 - removed autoinit for dos.library
.fi
